<template>
  <div>
    <transition name="scale-fade">
      <Win
        :number="resultNumber"
        @close="close"
        :gifUrl="gifUrl"
        v-show="win">
      </Win>
    </transition>
    <transition name="scale-fade">
      <Win
        :number="resultNumber"
        @close="close"
        :gifUrl="gifUrl"
        v-show="lose"
        type="lose">
      </Win>
    </transition>
  </div>
</template>

<script>
  import Win from './TheGameResults_win';

  export default {
    name: "GameResults",
    data() {
      return {
        win: false,
        lose: false,
        gifUrl: './backgrounds/gameResult_win.png'
      }
    },
    components: {
      Win
    },
    computed: {
      resultState() {
        return this.$store.state.game.myResult;
      },
      resultNumber() {
        return this.$store.state.game.winNumber;
      }
    },
    methods: {
      close(val) {
        this[val] = !this[val];
        this.$store.commit('game/SET_GAME_STATE_RESULT', {type: '', number: 0});
      },
      show(state) {
        this.generateGifUrl(state);
        if (state === 'win') {
          this.win = true;
        } else if (state === 'lose') {
          this.lose = true;
        }
      },
      generateGifUrl(type) {
        const name = parseInt(Math.random(1) * 12 + 1);
        const url = './gif/' + type + '/' + name + '.gif';
        this.gifUrl = url;
      },
    },
    watch: {
      'resultState': function () {
        if (this.resultState) {
          this.show(this.resultState);
        } else {
          //this.close();
        }
      }
    }
  }
</script>
